/*
 * indentDifference.h
 * Created by M.Miyazaki [2013.01.04]
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define TRUE	1
#define FALSE	0

/**
 * Default number of spaces that indicates tab length.
 */
#define DEFAULT_TAB_SPACES 4

/**
 * Accuracy of standard indent.
 */
#define INDENT_ACCURACY 1.0e-5

/**
 * List Node for histogram of standard indent.
 */
typedef struct HistogramNode
{
	struct HistogramNode *next;
	double normalIndent;
	int count;
} HistogramNode;

/**
 * List Node for indent information.
 */
typedef struct IndentListNode
{
	struct IndentListNode *next;
	int indentLevel;
	int indentSpaces;
	int indentTabs;
} IndentListNode;

/**
 * Function prototypes
 */
void setTabSpaces(int numberOfSpaces);
int registerIndent(int indentLevel, int indentSpaces, int indentTabs);
double calculateStandardIndent(void);
double calculateIndentDifference(void);
void freeIndentList(void);
