/*
 * typedefDictionary.h
 * Created by M.Miyazaki [2012.12.25]
 * Modified by M.Miyazaki [2012.12.28]
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/**
 * States for picking "typedef-name"s.
 */
enum TypedefState
{
	
	// Not a typedef statement but other.
	Initial,
	
	// It's in a typedef statement.
	InTypedef,
	
	// It's in the list of typedef name.
	InTypedefNameList
	
};

/**
 * Struct for typedef-name dictionary.
 */
typedef struct DictionaryElement
{
	
	// Next typedef-name element.
	struct DictionaryElement *next;
	
	// String literal of typedef-name.
	char *typedefName;
	
	// A number that indicates Scope level
	int scopeLevel;
	
} DictionaryElement;

/**
 * Extern variables
 */
extern enum TypedefState typedefState;
extern int currentScopeLevel;

/**
 * Function prototypes
 */
int isTypedefName(const char *typedefName);
int registerTypedefName(const char *typedefName, int scopeLevel);
int deleteTypedefNameAt(int scopeLevel);
int freeTypedefDictionary(void);
