<?php
#
# CodeSpaghetti - Metrics for SynapseScript
#  Created by M.Miyazaki [2013.01.04-2013.01.05]
#  Modified by M.Miyazaki [2013.01.06]
#


#-------------
# Preparation
#-------------
$waitTime      = base64_decode($_SERVER['argv'][1]);
$spaghettiName = base64_decode($_SERVER['argv'][2]);
$variability   = base64_decode($_SERVER['argv'][3]);
$oliveOil      = base64_decode($_SERVER['argv'][4]);
$imageFile     = base64_decode($_SERVER['argv'][5]);

$imageFile = basename($imageFile);

$htmlString = createRecipe($waitTime, $spaghettiName, $variability, $oliveOil, $imageFile);


#--------
# Output
#--------
print "{";
print "\"output\" : \"" . base64_encode($htmlString) . "\"";
print "}\n";


#-----------
# Functions
#-----------
function createRecipe($waitTime, $spaghettiName, $variability, $oliveOil, $imageFile)
{
	$htmlString = "";
	
	$htmlString .= htmlHeader();
	$htmlString .= htmlTableHeader();
	$htmlString .= htmlImage($imageFile, 300, 200);
	$htmlString .= htmlTableRow("料理名", $spaghettiName);
	$htmlString .= htmlTableRow("ゆで上げ後の待ち時間[分]", $waitTime);
	$htmlString .= htmlTableRow("ゆで具合のばらつき[分]", $variability);
	$htmlString .= htmlTableRow("乾燥防止のオリーブオイル", $oliveOil);
	$htmlString .= htmlTableFooter();
	$htmlString .= htmlFooter();
	
	return $htmlString;
}

function htmlHeader()
{
	$headerString = "";
	
	$headerString .= "<!DOCTYPE html>\n";
	$headerString .= "<html lang=\"ja\">\n";
	$headerString .= "  <head>\n";
	$headerString .= "    <meta charset=\"UTF-8\" />\n";
	$headerString .= "    <title>Code Spaghetti</title>\n";
	$headerString .= "    <style type=\"text/css\">\n";
	$headerString .= "    <!--\n";
	$headerString .= "    /* Original CSS */\n";
	$headerString .= "    table {\n";
	$headerString .= "        border-collapse : collapse;\n";
	$headerString .= "        border-top : 1px solid #999999;\n";
	$headerString .= "        border-left : 1px solid #999999;\n";
	$headerString .= "    }\n";
	$headerString .= "    th {\n";
	$headerString .= "        border-right : 1px solid #999999;\n";
	$headerString .= "        border-bottom : 1px solid #999999;\n";
	$headerString .= "        background-color : #e9e9e9;\n";
	$headerString .= "        padding : 5px;\n";
	$headerString .= "    }\n";
	$headerString .= "    td {\n";
	$headerString .= "        border-right : 1px solid #999999;\n";
	$headerString .= "        border-bottom : 1px solid #999999;\n";
	$headerString .= "        padding : 5px;\n";
	$headerString .= "    }\n";
	$headerString .= "    -->\n";
	$headerString .= "    </style>\n";
	$headerString .= "  </head>\n";
	$headerString .= "  <body>\n";
	
	return $headerString;
}

function htmlImage($imageFile, $width, $height)
{
	$imageString = "";
	
	$imageString .= "    <a href=\"";
	$imageString .= htmlspecialchars($imageFile);
	$imageString .= "\"><img src=\"";
	$imageString .= htmlspecialchars($imageFile);
	$imageString .= "\" width=\"";
	$imageString .= htmlspecialchars($width);
	$imageString .= "\" height=\"";
	$imageString .= htmlspecialchars($height);
	$imageString .= " alt=\"Spaghetti Image\"></a>\n";
	
	return $imageString;
}

function htmlTableHeader()
{
	$headerString = "";
	
	$headerString .= "    <table>\n";
	$headerString .= "      <tbody>\n";
	
	return $headerString;
}

function htmlTableRow($key = "", $value = "")
{
	$rowString = "";
	
	$rowString .= "        <tr>";
	$rowString .= "<th>" . htmlspecialchars($key) . "</th>";
	$rowString .= "<td>" . htmlspecialchars($value) . "</td>";
	$rowString .= "</tr>\n";
	
	return $rowString;
}

function htmlTableFooter()
{
	$footerString = "";
	
	$footerString .= "      </tbody>\n";
	$footerString .= "    </table>\n";
	
	return $footerString;
}

function htmlFooter()
{
	$footerString = "";
	
	$footerString .= "  </body>\n";
	$footerString .= "</html>\n";
	
	return $footerString;
}
?>