/**
 * CommentRatio2OliveOil - Metrics for SynapseScript
 *
 *  Created by M.Miyazaki [2013.01.04]
 *  Modified by M.Miyazaki [2013.01.08]
 */
public class CommentRatio2OliveOil extends Object
{
	
	/**
	 * Portion of Olive oil for one person.
	 */
	private static String portionOfOliveOil(double commentRatio)
	{
		String aString = null;
		
		if (commentRatio <  10.0)      { aString = "なし"; }
		else if (commentRatio < 20.0) { aString = "少量"; }
		else if (commentRatio < 50.0) { aString = "適量"; }
		else if (commentRatio < 80.0) { aString = "大量"; }
		else                          { aString = "オイル漬け"; }
		
		return aString;
	}
	
	/**
	 * Main routine.
	 */
	public static void main(String[] arguments)
	{
		String portionOfOliveOil = null;
		
		if (arguments.length >= 1)
		{
			try
			{
				double commentRatio = (new Double(arguments[0])).doubleValue();
				if (0.0 <= commentRatio && commentRatio <= 100.0)
				{
					portionOfOliveOil = CommentRatio2OliveOil.portionOfOliveOil(commentRatio);
				}
			}
			catch (NumberFormatException anException) { /* Ingore */ }
		}
		
		if (portionOfOliveOil == null)
		{
			portionOfOliveOil = "？？？";
		}
		
		System.out.printf("%s", portionOfOliveOil);
		
		return;
		
	}
	
}