#
# Division2.sh
#
#  Created by M.Miyazaki [2013.01.06]
#

#!/bin/sh

if [ "`printf 'hoge' | base64 --wrap=0 2>/dev/null | base64 -d 2>/dev/null`" = "hoge" ]
then
	alias encodeBase64='base64 --wrap=0'
	alias decodeBase64='base64 --decode'
	#alias decodeBase64='base64 -d'
else
	alias encodeBase64='base64 --break=0'
	alias decodeBase64='base64 --decode'
	#alias decodeBase64='base64 -D'
fi

ScriptString=`cat <<EndOfScript

use POSIX;
use MIME::Base64;

\\\$dividend = \\\$ARGV[0];
\\\$divisor = \\\$ARGV[1];

\\\$quotient = 0;
\\\$floorQuotient = 0;
\\\$remainder = 0;

if (\\\$divisor == 0)
{
	if (\\\$dividend == 0)
	{
		\\\$quotient = "NaN";
		\\\$floorQuotient = "NaN";
		\\\$remainder = "NaN";
	}
	else
	{
		if ((\\\$dividend >= 0 && \\\$divisor eq "-0") || (\\\$dividend < 0 && \\\$divisor eq "0"))
		{
			\\\$quotient = "-Infinity";
			\\\$floorQuotient = "-Infinity";
			\\\$remainder = "-Infinity";
		}
		else
		{
			\\\$quotient = "Infinity";
			\\\$floorQuotient = "Infinity";
			\\\$remainder = "Infinity";
		}
	}
}
else
{
	\\\$quotient = \\\$dividend / \\\$divisor;
	\\\$floorQuotient = floor(\\\$dividend / \\\$divisor);
	if (-1 < \\\$divisor && \\\$divisor < 1)
	{
		\\\$remainder = "Error";
	}
	else
	{
		\\\$remainder = \\\$dividend % \\\$divisor;
	}
}

\\\$quotient      = encode_base64(\\\$quotient);
\\\$floorQuotient = encode_base64(\\\$floorQuotient);
\\\$remainder     = encode_base64(\\\$remainder);

chomp \\\$quotient;
chomp \\\$floorQuotient;
chomp \\\$remainder;

print "{\"quotient\" : \"\\\$quotient\", \"floorQuotient\" : \"\\\$floorQuotient\", \"remainder\" : \"\\\$remainder\"}\n";

EndOfScript`

dividend=`printf "%s" "${1}" | decodeBase64`
divisor=`printf "%s" "${2}" | decodeBase64`

perl -e "${ScriptString}" "${dividend}" "${divisor}"
