#!/bin/sh
#
# IndentDifference2VariabilityOfBoilingTime - Metrics for SynapseScript
#  Created by M.Miyazaki [2013.01.04]
#  Modified by M.Miyazaki [2013.01.08]
#


#----------
# Settings
#----------

# Proportionality Constant
Proportionality="10"

#----------


if [ "`printf 'hoge' | base64 --wrap=0 2>/dev/null | base64 -d 2>/dev/null`" = "hoge" ]
then
	alias encodeBase64='base64 --wrap=0'
	alias decodeBase64='base64 --decode'
	#alias decodeBase64='base64 -d'
else
	alias encodeBase64='base64 --break=0'
	alias decodeBase64='base64 --decode'
	#alias decodeBase64='base64 -D'
fi

InputString="${1}"
InputValue=`printf "${InputString}" | decodeBase64`
OutputValue=`ruby -e 'print ARGV[0].to_f * ARGV[1].to_f' "${Proportionality}" "${InputValue}"`
OutputString=`printf "%s" "${OutputValue}" | encodeBase64`

printf "{\"output\" : \"%s\"}\n" "${OutputString}"
