<?php
#
# MetricsTable - Metrics for SynapseScript
#  Created by M.Miyazaki [2013.01.05]
#


#-------------
# Preparation
#-------------
$arguments = $_SERVER['argv'];
$valueList = array(
	"Lines Of Code"           => $arguments[1],
	"Effective LOC"           => $arguments[2],
	"Physical LOC"            => $arguments[3],
	"Logical LOC"             => $arguments[4],
	"Comment Lines"           => $arguments[5],
	"Number Of Functions"     => $arguments[6],
	"Lines Per Function"      => $arguments[7],
	"Average Of Length"       => $arguments[8],
	"Indent Difference"       => $arguments[9],
	"Standard Indent"         => $arguments[10],
	"Comment Ratio (%)"       => $arguments[11],
	"Wait Time after boiling" => $arguments[12],
	"Spaghetti Name"          => $arguments[13],
	"Variability"             => $arguments[14],
	"Degradation"             => $arguments[15],
	"Olive Oil"               => $arguments[16]
);


#--------
# Output
#--------
print "{";
print "\"output\" : \"" . base64_encode(createMetricsTable($valueList)) . "\"";
print "}\n";


#-----------
# Functions
#-----------
function createMetricsTable($valueList = null)
{
	if ($valueList == null) { return ""; }
	$htmlString = "";
	
	$htmlString .= htmlHeader();
	$htmlString .= htmlTableHeader();
	foreach ($valueList as $key => $value)
	{
		$htmlString .= htmlTableRow($key, base64_decode($value));
	}
	$htmlString .= htmlTableFooter();
	$htmlString .= htmlFooter();
	
	return $htmlString;
}

function htmlHeader()
{
	$headerString = "";
	
	$headerString .= "<!DOCTYPE html>\n";
	$headerString .= "<html lang=\"ja\">\n";
	$headerString .= "  <head>\n";
	$headerString .= "    <meta charset=\"UTF-8\" />\n";
	$headerString .= "    <title>Metrics Table</title>\n";
	$headerString .= "    <style type=\"text/css\">\n";
	$headerString .= "    <!--\n";
	$headerString .= "    /* Original CSS */\n";
	$headerString .= "    table {\n";
	$headerString .= "        border-collapse : collapse;\n";
	$headerString .= "        border-top : 1px solid #999999;\n";
	$headerString .= "        border-left : 1px solid #999999;\n";
	$headerString .= "    }\n";
	$headerString .= "    th {\n";
	$headerString .= "        border-right : 1px solid #999999;\n";
	$headerString .= "        border-bottom : 1px solid #999999;\n";
	$headerString .= "        background-color : #e9e9e9;\n";
	$headerString .= "        padding : 5px;\n";
	$headerString .= "    }\n";
	$headerString .= "    td {\n";
	$headerString .= "        border-right : 1px solid #999999;\n";
	$headerString .= "        border-bottom : 1px solid #999999;\n";
	$headerString .= "        padding : 5px;\n";
	$headerString .= "    }\n";
	$headerString .= "    -->\n";
	$headerString .= "    </style>\n";
	$headerString .= "  </head>\n";
	$headerString .= "  <body>\n";
	
	return $headerString;
}

function htmlTableHeader()
{
	$headerString = "";
	
	$headerString .= "    <table>\n";
	$headerString .= "      <tbody>\n";
	
	return $headerString;
}

function htmlTableRow($key = "", $value = "")
{
	$rowString = "";
	
	$rowString .= "        <tr>";
	$rowString .= "<th>" . htmlspecialchars($key) . "</th>";
	$rowString .= "<td>" . htmlspecialchars($value) . "</td>";
	$rowString .= "</tr>\n";
	
	return $rowString;
}

function htmlTableFooter()
{
	$footerString = "";
	
	$footerString .= "      </tbody>\n";
	$footerString .= "    </table>\n";
	
	return $footerString;
}

function htmlFooter()
{
	$footerString = "";
	
	$footerString .= "  </body>\n";
	$footerString .= "</html>\n";
	
	return $footerString;
}